unit Unit1;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, DBCtrls, Grids, DBGrids, ExtCtrls, DB, DBClient, StdCtrls, Buttons,
	ComCtrls, MidasLib, Menus, ActnPopup,
	JvExDBGrids, JvDBGrid, JvComponentBase,
	JvAppStorage, JvAppDBStorage, JvAppStorageSelectList, JvAppIniStorage,
	JvFormPlacementSelectList, JvFormPlacement, PlatformDefaultStyleActnCtrls,
	JvDBUltimGrid, JvExGrids, JvStringGrid;

type
	TForm1 = class(TForm)
		CDS1: TClientDataSet;
		DS1: TDataSource;
		Panel1: TPanel;
		Panel2: TPanel;
		DBNavigator1: TDBNavigator;
		PanelSize: TPanel;
		Panel3: TPanel;
		DBGrid1: TDBGrid;
    JvDBUltimGrid1: TJvDBUltimGrid;
		RadioGroupDrawingStyle: TRadioGroup;
		GroupBox1: TGroupBox;
		Label1: TLabel;
		CheckBoxEnableSorting: TCheckBox;
		CheckBoxEnableExcludedFields: TCheckBox;
		EditSortExcludedFields: TEdit;
		ButtonDefaultSorting: TButton;
		GroupBox2: TGroupBox;
		LabeledEditFixedCols: TLabeledEdit;
		CheckBoxMultiSelect: TCheckBox;
		CheckBoxRowSelect: TCheckBox;
		UpDownFixedCols: TUpDown;
		Memo1: TMemo;
		Splitter1: TSplitter;
		Bevel1: TBevel;
		Bevel2: TBevel;
		procedure DS1DataChange(Sender: TObject; Field: TField);
		procedure FormCreate(Sender: TObject);
		procedure RadioGroupDrawingStyleClick(Sender: TObject);
		procedure UpDownFixedColsClick(Sender: TObject; Button: TUDBtnType);
		procedure CheckBoxMultiSelectClick(Sender: TObject);
		procedure CheckBoxRowSelectClick(Sender: TObject);
		procedure JvDBUltimGrid1TitleBtnClick(Sender: TObject; ACol: Integer;
			Field: TField);
		procedure JvDBUltimGrid1TitleBtnDblClick(Sender: TObject; ACol: Integer;
			Field: TField);
		procedure JvDBUltimGrid1TitleClick(Column: TColumn);
		procedure CheckBoxEnableSortingClick(Sender: TObject);
		procedure ButtonDefaultSortingClick(Sender: TObject);
		procedure CheckBoxEnableExcludedFieldsClick(Sender: TObject);
		procedure EditSortExcludedFieldsChange(Sender: TObject);
		procedure JvDBUltimGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
			DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
	private
		{ Private declarations }
		procedure ColorTextField(Sender: TObject;
			const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
	public
		{ Public declarations }
	end;

var
	Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
	UpDownFixedCols.Position := 1;
	with JvDBUltimGrid1 do
	begin
		FixedCols := UpDownFixedCols.Position;
		RadioGroupDrawingStyle.ItemIndex := Ord(DrawingStyle);

//		ColumnResize := gcrDataSet;

//		SortWith := swClient;
//		RestoreOnSort := False;

	end;
end;

procedure TForm1.ColorTextField(Sender: TObject;
	const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
	if SameText(Column.FieldName, 'Text') then begin
		with TDBGrid(Sender) do begin
			Canvas.Brush.Color:=clTeal;
			Canvas.Font.Style:=[fsBold];
			if not(State = [gdSelected, gdFocused]) then
				Canvas.Font.Color:=clYellow
			else
				Canvas.Font.Color:=clAqua;
		end;
	end;
end;

procedure TForm1.JvDBUltimGrid1DrawColumnCell(Sender: TObject;
	const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
	ColorTextField(Sender, Rect, DataCol, Column, State);

	{ Default behaviour }
	TDBGrid(Sender).DefaultDrawColumnCell(Rect, DataCol, Column, State);

	{ Fixed behaviour }
	TJvDBUltimGrid(Sender).DefaultDrawColumnCell(Rect, DataCol, Column, State); // Comment this line for default behaviour.

end;

procedure TForm1.JvDBUltimGrid1TitleBtnClick(Sender: TObject; ACol: Integer;
	Field: TField);
begin
	Memo1.Lines.Add('TitleBtnClick');
end;

procedure TForm1.JvDBUltimGrid1TitleBtnDblClick(Sender: TObject; ACol: Integer;
	Field: TField);
begin
	Memo1.Lines.Add('TitleBtnDbClick');
end;

procedure TForm1.JvDBUltimGrid1TitleClick(Column: TColumn);
begin
	Memo1.Lines.Add('TitleClick');
end;

procedure TForm1.RadioGroupDrawingStyleClick(Sender: TObject);
begin
	JvDBUltimGrid1.DrawingStyle := TGridDrawingStyle
		(TRadioGroup(Sender).ItemIndex);
	DBGrid1.DrawingStyle := JvDBUltimGrid1.DrawingStyle;
end;

procedure TForm1.UpDownFixedColsClick(Sender: TObject; Button: TUDBtnType);
begin
	JvDBUltimGrid1.FixedCols := TUpDown(Sender).Position;
end;

procedure TForm1.ButtonDefaultSortingClick(Sender: TObject);
begin
	JvDBUltimGrid1.ClearSortedFields;
	CDS1.IndexFieldNames := CDS1.Fields[0].FieldName;
end;

procedure TForm1.CheckBoxEnableExcludedFieldsClick(Sender: TObject);
begin
	if TCheckBox(Sender).Checked then
		JvDBUltimGrid1.SortExcludedFields := Trim(EditSortExcludedFields.Text)
	else
		JvDBUltimGrid1.SortExcludedFields := '';
end;

procedure TForm1.CheckBoxEnableSortingClick(Sender: TObject);
begin
	JvDBUltimGrid1.AutoSort := TCheckBox(Sender).Checked;
end;

procedure TForm1.CheckBoxMultiSelectClick(Sender: TObject);
begin
	JvDBUltimGrid1.MultiSelect := CheckBoxMultiSelect.Checked;
	if CheckBoxMultiSelect.Checked then
		DBGrid1.Options := DBGrid1.Options + [dgMultiSelect]
	else
		DBGrid1.Options := DBGrid1.Options - [dgMultiSelect];
end;

procedure TForm1.CheckBoxRowSelectClick(Sender: TObject);
begin
	if CheckBoxRowSelect.Checked then
	begin
		JvDBUltimGrid1.Options := JvDBUltimGrid1.Options + [dgRowSelect];
		DBGrid1.Options := DBGrid1.Options + [dgRowSelect];
	end
	else
	begin
		JvDBUltimGrid1.Options := JvDBUltimGrid1.Options - [dgRowSelect];
		DBGrid1.Options := DBGrid1.Options - [dgRowSelect];
	end;
end;

procedure TForm1.DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
	ColorTextField(Sender, Rect, DataCol, Column, State);
	TDBGrid(Sender).DefaultDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TForm1.DS1DataChange(Sender: TObject; Field: TField);
begin
	PanelSize.Caption := IntToStr(TDataSource(Sender).DataSet.RecordCount);
end;

procedure TForm1.EditSortExcludedFieldsChange(Sender: TObject);
begin
	JvDBUltimGrid1.SortExcludedFields := Trim(EditSortExcludedFields.Text);
end;

end.
